<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">

    <ui:define name="body">
        <br/>
        <s:div id="globalDiv">
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.vut.UnitTestDetails']}</f:facet>
                <br/>
                <div class="form-horizontal">
                    <h:form id="testDetailsForm">
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:define name="label">#{messages['gazelle.vut.Keyword']}</ui:define>
                            <ui:param name="id" value="keywordInput"/>
                            <h:inputText id="keywordInput"
                                         value="#{validatorIntegrationTestEditorManager.unitTest.keyword}"
                                         required="true"
                                         requiredMessage="The keyword is a mandatory attribute"
                                         size="100" styleClass="form-control"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:define name="label">#{messages['gazelle.vut.Active']}</ui:define>
                            <ui:param name="id" value="activeInput"/>
                            <h:selectBooleanCheckbox id="activeInput"
                                                     value="#{validatorIntegrationTestEditorManager.unitTest.active}"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:define name="label">#{messages['gazelle.vut.ExpectedResult']}</ui:define>
                            <ui:param name="id" value="resInput"/>
                            <h:selectOneMenu id="resInput"
                                             value="#{validatorIntegrationTestEditorManager.unitTest.expectedResult}"
                                             styleClass="form-control gzl-form-control gzl-select-text">
                                <f:selectItems
                                        value="#{validatorIntegrationTestEditorManager.availableResults}"/>
                            </h:selectOneMenu>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:define name="label">#{messages['gazelle.vut.Comment']}</ui:define>
                            <ui:param name="id" value="commentInput"/>
                            <h:inputTextarea id="commentInput"
                                             value="#{validatorIntegrationTestEditorManager.unitTest.comment}"
                                             rows="3" cols="80" style="resize:both;" styleClass="form-control"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:param name="id" value="valOuput"/>
                            <h:outputText id="valOuput"
                                          value="#{messages['net.ihe.gazelle.xdstar.SelectTheValidatorForWhichYouWantToAddAFile']}"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.ValidatorName_2']}</ui:define>
                            <ui:param name="id" value="selectCar"/>
                            <h:selectOneMenu id="selectCar"
                                             value="#{validatorIntegrationTestEditorManager.unitTest.testedValidator}"
                                             styleClass="form-control gzl-form-control gzl-select-text">
                                <s:selectItems
                                        value="#{validatorIntegrationTestEditorManager.getAvailableValidatorPackClass()}"
                                        var="cl"
                                        noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.SelectAValue']}"
                                        label="#{cl.validatorName}"/>
                            </h:selectOneMenu>
                        </s:decorate>

                        <br/>
                        <br/>
                        <s:div id="uploadId">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.xdstar.ImportFile']}"
                                               styleClass="gzl-btn-blue"
                                               oncomplete="jq162('#upload_file').modal('show');"/>
                            <h:commandButton value="#{messages['net.ihe.gazelle.xdstar.DownloadFile']}"
                                             styleClass="gzl-btn-blue"
                                             action="#{validatorIntegrationTestEditorManager.downloadFile()}"
                                             render="textExport" target="_blank"
                                             rendered="#{validatorIntegrationTestEditorManager.unitTest.testedFilePath != null}"/>
                            <br/>
                            <s:div id="fileUploadId"
                                   rendered="#{validatorIntegrationTestEditorManager.uploadedFile != null}">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.xdstar.FileUploadedPleaseSaveYourChangesAndorUploadBefo']}"/>
                            </s:div>
                        </s:div>
                        <br/>
                        <br/>
                        <ui:insert name="extraUnitTestAttributes"/>
                        <s:div id="detailedResultDiv"
                               rendered="#{validatorIntegrationTestEditorManager.unitTest.executed()}">

                            <gri:panel>
                                <f:facet name="header">#{messages['net.ihe.gazelle.xdstar.DetailedResult']}
                                    <h:outputText
                                            value="#{validatorIntegrationTestManager.getLastResultLabel(validatorIntegrationTestEditorManager.unitTest)}"
                                            styleClass="#{validatorIntegrationTestManager.getLastResultStyle(validatorIntegrationTestEditorManager.unitTest)}"/>
                                </f:facet>
                                <s:decorate template="/layout/display/_display.xhtml">
                                    <ui:define name="label">#{messages['gazelle.vut.LastRunDate']}</ui:define>
                                    <g:date
                                            value="#{validatorIntegrationTestEditorManager.unitTest.lastRunDate}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_display.xhtml"
                                            rendered="#{validatorIntegrationTestEditorManager.unitTest.lastSuccessDate != nll}">
                                    <ui:define name="label">#{messages['gazelle.vut.LastSucessDate']}</ui:define>
                                    <g:date
                                            value="#{validatorIntegrationTestEditorManager.unitTest.lastSuccessDate}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_display.xhtml"
                                            rendered="#{not empty validatorIntegrationTestEditorManager.unitTest.reasonForFailure}">
                                    <ui:define name="label">#{messages['gazelle.vut.ReasonForFailure']}</ui:define>
                                    <h:outputText
                                            value="#{validatorIntegrationTestEditorManager.unitTest.reasonForFailure}"/>
                                </s:decorate>

                                <a4j:commandButton value="#{messages['net.ihe.gazelle.xdstar.UndisplayResult']}"
                                                   render="detailedResultDiv"
                                                   rendered="#{validatorIntegrationTestEditorManager.isDisplayDetailedResult()}"
                                                   styleClass="gzl-btn-blue"
                                                   actionListener="#{validatorIntegrationTestEditorManager.actionListener}"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.xdstar.DisplayResult']}"
                                                   render="detailedResultDiv"
                                                   rendered="#{!validatorIntegrationTestEditorManager.isDisplayDetailedResult()}"
                                                   styleClass="gzl-btn-blue"
                                                   actionListener="#{validatorIntegrationTestEditorManager.actionListener}"/>
                                <h:commandButton value="#{messages['net.ihe.gazelle.xdstar.DownloadDetailedResult']}"
                                                 action="#{validatorIntegrationTestManager.downloadDetailedResult(validatorIntegrationTestEditorManager.unitTest)}"
                                                 render="textExport" target="_blank"
                                                 styleClass="gzl-btn-blue"/>

                                <h:outputText id="detailedResultString" escape="false"
                                              rendered="#{validatorIntegrationTestEditorManager.isDisplayDetailedResult()}"
                                              value="#{validatorIntegrationTestManager.getDetailedResult(validatorIntegrationTestEditorManager.unitTest)}"/>


                            </gri:panel>

                        </s:div>

                        <br/>
                        <br/>

                        <a4j:commandButton value="#{messages['gazelle.vut.Save']}" styleClass="gzl-btn-green"
                                           actionListener="#{validatorIntegrationTestEditorManager.save()}"
                                           render="globalDiv"/>
                        <a4j:commandButton value="#{messages['gazelle.vut.RunTest']}" styleClass="gzl-btn-green"
                                           action="#{validatorIntegrationTestManager.executeTestAndRefreshPage(validatorIntegrationTestEditorManager.unitTest)}"
                                           render="utDetails"/>
                        <a4j:commandButton value="#{messages['gazelle.vut.ShowLogs']}" styleClass="gzl-btn-blue"
                                           action="#{validatorIntegrationTestManager.displayUnitTestLogs(validatorIntegrationTestEditorManager.unitTest)}"/>
                        <h:commandButton value="#{messages['net.ihe.gazelle.xdstar.BackToList']}" styleClass="gzl-btn"
                                         action="/testing/browseUnitTests.xhtml" immediate="true"/>
                    </h:form>
                    <h:form>
                        <gri:popupPanel id="upload_file">
                            <f:facet name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.xdstar.UploadFile']}"/>
                            </f:facet>
                            <f:facet name="footer">
                                <div align="right">
                                    <a4j:commandButton value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                                       styleClass="gzl-btn"
                                                       onclick="jq162('#upload_file').modal('hide');"
                                                       ajaxSingle="true"/>
                                    <a4j:commandButton value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                                       styleClass="gzl-btn-green"
                                                       action="#{validatorIntegrationTestEditorManager.importFile()}"
                                                       render="globalForm,messageDecoration"
                                                       onclick="jq162('#upload_file').modal('hide');"/>


                                </div>
                            </f:facet>


                            <rich:fileUpload id="uploadFile"
                                             fileUploadListener="#{validatorIntegrationTestEditorManager.uploadListener}"
                                             maxFilesQuantity="1" acceptedTypes="xml,zip" listHeight="60px"
                                             immediateUpload="true">
                                <a4j:ajax event="uploadcomplete" render="uploadId"/>
                            </rich:fileUpload>


                        </gri:popupPanel>
                    </h:form>
                </div>
            </gri:panel>
        </s:div>
    </ui:define>
</ui:composition>